//---------------------------------------------------------------------------
#ifndef dropfileH
#define dropfileH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#include <win32\shellapi.h>
//---------------------------------------------------------------------------
typedef void __fastcall (__closure *TDropFileEvent) (TObject *Sender, String FileWithPath, String FileName, String Extension);
//---------------------------------------------------------------------------
class TDropFile : public TComponent
{
private:
    bool FEnabled;				// Enabled or not
    TWinControl *FDropTarget;
    HWND WindowHandle;			// Pointer to the main wind
    void* DefProc;				// Pointer to old messagehandler procedure
    void* WndProcInstance;		// Pointer to new message handler procedure
   	TDropFileEvent FOnDropFile;

protected:
	void __fastcall SetEnabled(bool Value);
    void __fastcall SubWndProc(TMessage& Msg);     // SubWndProc = WndProc
    void __fastcall InitControl();
    void __fastcall DestroyControl();
	void __fastcall DropFiles(HDROP hDropHandle);

public:
	__fastcall TDropFile(TComponent* Owner);
	__fastcall ~TDropFile(void);
    void __fastcall SetDropTarget(TWinControl* nDropTarget);

__published:
    __property bool EnableDrop = {read = FEnabled, write = SetEnabled, default=true};
	__property TWinControl *DropTarget = {read=FDropTarget, write=SetDropTarget};
    __property TDropFileEvent OnDropFile = {read = FOnDropFile, write = FOnDropFile};

};
//---------------------------------------------------------------------------
#endif
